# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [2.0.0] - 2022-08-31

- Compatible with MicroEJ UI Pack 13.3.0 or higher.

### Changed

- Improve `drawImage`: identify faster use cases (copy an image and draw a region with overlap).
- Use new MicroEJ UI Pack 13.3.0 API: `UI_DRAWING_copyImage` and `UI_DRAWING_drawRegion`. 
- Use new MicroUI's native functions declaration (not backward compatible).

## [1.1.1] - 2022-04-27

- Compatible with MicroEJ UI Pack 13.1.0 or higher.

### Fixed

- Fix the license and copyrights: use BSD License.
- Fix Misra rules.

## [1.1.0] - 2021-07-16

- Compatible with MicroEJ UI Pack 13.1.0 or higher.

### Added

- Add MicroUI events logger.
- Add MicroUI images heap allocator.

### Fixed

- Fix comments in `LLUI_PAINTER_impl.c` and `LLDW_PAINTER_impl.c`.
- Ignore a drawing when at least one scaling factor is equal to zero.

## [1.0.3] - 2020-12-08

- Compatible with MicroEJ UI Pack 13.0.0 or higher.

### Fixed

- Fix missing license file.

## [1.0.2] - 2020-09-02

- Compatible with MicroEJ UI Pack 13.0.0 or higher.

### Changed

- Fix artifact organization.

## [1.0.1] - 2020-07-28

- Compatible with MicroEJ UI Pack 13.0.0 or higher.

### Changed

- Fix MISRA C 2004 rule 13.3.
- Rename some parameters.
- Clamp user's alpha value instead throwing an exception.
- Rename readPixel in writePixel.

## [1.0.0] - 2020-04-09

- Initial revision (deprecated version).
- Implements `LLGRAPHICS_impl.h` and `LLGRAPHICS_EXT_impl.h` functions (MicroUI native functions).
- Log all drawings.
- Dispatch all drawings to the implementation of `DRAWING_impl.h`

---
_Copyright 2020-2022 MicroEJ Corp. All rights reserved._  
_Use of this source code is governed by a BSD-style license that can be found with this software._  
