# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [1.6.1] - 2022-03-14

### Changed

  - Migrate module to MMM
  - Update `LICENSE.txt` to latest ESR license 

## [1.6.0] - 2021-07-29

### Added

  - Add an API to know if a Feature can be uninstalled: `Kernel.canUninstall()`.

## [1.5.1] - 2021-03-25

### Added

  - Mark APIs for Null Analysis
  
### Fixed

  - Make `Module` constructor private
 

## [1.5.0] - 2021-03-11

### Added

  - Add Memory Control support with the following API:
    - `ej.kf.Feature.getCriticality()`
    - `ej.kf.Feature.setCriticality()`
    - `ej.kf.Feature.MIN_CRITICALITY`
    - `ej.kf.Feature.NORM_CRITICALITY`
    - `ej.kf.Feature.MAX_CRITICALITY`
    - `ej.kf.Kernel.addResourceControlListener()`
    - `ej.kf.Kernel.removeResourceControlListener()`
    - `ej.kf.ResourceControlListener`
  
### Fixed

  - Fix following methods can throw an `IllegalStateException` if the referenced Feature is not started:
    - `Kernel.runUnderContext()`
    - `Kernel.setOwner()`
    - `Kernel.clone()`
    - `Kernel.bind()`
    - `Kernel.newProxy()`

## [1.4.4] - 2018-09-21

### Fixed

  - Remove unused API `Kernel.setOwner` which is not in ESR specifications.

## [1.4.3] - 2017-02-21

### Fixed

  - Bad signature of `ej.kf.Proxy.invokeFloat`.

## [1.4.2] - 2016-04-01

### Added

  - Initial public revision.

---
_Markdown_  
_2016-2022 ESR - Not subject to Copyright._  

_This document has been released and published by E-S-R consortium, a non-profit entity._  
_To learn more about E-S-R consortium, please visit http://www.e-s-r.net/._  
_The matter contained in this document is not subject to copyright; you are free to use it for any purpose, for more information see E-S-R consortium policies._