# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).


## 2.3.1 - 2019-09-10

### Fixed

  - Fix an IndexOutOfBoundsException when showing a panel after a dialog.
  - Fix missing show notification when showing a panel after a dialog.

## 2.3.0 - 2019-02-28

### Changed

  - Use MMM.
  
### Added

  - Set the api dependencies as provided.

## 2.2.5 - 2018-12-05

### Added

  - Add null analysis annotations.

## 2.2.4 - 2018-07-04

### Fixed

  - Fix ArrayIndexOutOfBoundsException thrown when changing focus on composites that don't keep all children in hierarchy.

## 2.2.3 - 2018-03-13

### Fixed

  - Remove absolute bounds computation.
  - Inline some method calls.

## 2.2.2 - 2017-07-03

### Fixed

  - Fix panel child bounds.

## 2.2.1 - 2017-06-23

### Fixed

  - Renderables under the pointer now receive exit event when another renderable captures the pointer session.
  - Desktop now always uses the same mechanism as the widgets to be repaint to avoid possible flickering.
  - Do not repaint widget when calling setEnabled() without changing the current value.
  - Fix dialog hiding (method show may block even after the dialog is hidden).

## 2.2.0 - 2017-02-13

  - Released as an add-on library.

### Added

  - Replace _show_ methods in panel by more explicit ones.
  - Add revalidate method to re-layout a subset of a panel.

### Fixed

  - Do not paint invisible widgets.

## 2.1.11 - 2017-01-04

### Added

  - Optimize flush.

### Fixed

  - Width and height of a invisible widget is set to 0 only when revalidated.

## 2.1.10 - 2016-12-21

### Fixed

  - Call lost focus on a widget when it is effectively unlinked from the panel.

## 2.1.9 - 2016-10-19

### Fixed

  - Call show notify on a widget when it is effectively linked to a panel.

## 2.1.8 - 2016-01-07

### Fixed

  - Fix the refresh of a not active panel(s) when two (or more) panels are shown.

## 2.1.7 - 2016-09-07

### Fixed

  - Check creation of inconsistent hierarchy (widget with several parents).


---  
_Copyright 2018-2019 MicroEJ Corp. All rights reserved._  
_This library is provided in source code for use, modification and test, subject to license terms._  
_Any modification of the source code will break MicroEJ Corp. warranties on the whole library._  