/*
 * Java
 *
 * Copyright 2015-2017 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package ej.microui.event.controller;

/**
 * Helps dispatch some sorts of events.
 *
 * @since 2.0
 */
public class DispatchHelper {

	private DispatchHelper() {
	}

	/**
	 * Dispatch MicroUI events.
	 *
	 * @param event
	 *            the event to dispatch.
	 * @param eventGeneratorsHandler
	 *            the handler to dispatch to.
	 * @return <code>true</code> if the event is consumed, <code>false</code> otherwise.
	 */
	public static boolean dispatchEvent(int event, EventGeneratorsHandler eventGeneratorsHandler) {
		throw new RuntimeException();
	}

	/**
	 * Dispatch button events.
	 *
	 * @param event
	 *            the event to dispatch.
	 * @param buttonEventHandler
	 *            the handler to dispatch to.
	 * @return <code>true</code> if the event is consumed, <code>false</code> otherwise.
	 */
	public static boolean dispatchButton(int event, ButtonEventHandler buttonEventHandler) {
		throw new RuntimeException();
	}

	/**
	 * Dispatch pointer events.
	 *
	 * @param event
	 *            the event to dispatch.
	 * @param pointerEventHandler
	 *            the handler to dispatch to.
	 * @return <code>true</code> if the event is consumed, <code>false</code> otherwise.
	 */
	public static boolean dispatchPointer(int event, PointerEventHandler pointerEventHandler) {
		throw new RuntimeException();
	}

}
