# Overview

MicroEJ Add-On Library: `jakarta-regexp`.

This is a Regular Expression processing library.

It is a fork of [Jakarta Regexp](https://attic.apache.org/projects/jakarta-regexp.html) library for MicroEJ. It has been forked from the last available version (1.5). It uses the [regexp-me](https://code.google.com/archive/p/regexp-me/) `RECharacter` class instead of the [`Character`](https://docs.oracle.com/javase/7/docs/api/java/lang/Character.html) class in EDC which does not provide all the necessary advanced features for this library.

# Usage

Add the following line to your `module.ivy`:

    <dependency org="org.apache" name="jakarta-regexp" rev="1.0.0"/>

Here is the basic example of pattern matching:

```Java
RE r = new RE("abc(\\w*)"); // Create new pattern
if (r.match("abcdefg")) { // Match pattern
	System.out.println("oh yeah!"); // Oh Yeah!
}
```

# Requirements

This library requires the following Foundation Libraries:

    EDC-1.3

# Dependencies

_All dependencies are retrieved transitively by MicroEJ Module Manager_.

# Source

N/A.

# Restrictions

None.

---  
_Copyright 2022 MicroEJ Corp. This file has been modified by MicroEJ Corp._  